'' =================================================================================================
''
''   File....... Hexapod Test Programs.spin
''   Purpose.... Create series of test routines for leg control
''   Author..... Bob Sweeney
''   Started.... 
''
'' =================================================================================================

con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  
con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28

  CS  =  27
  CLK =  26
  DIO =  9

obj
  io            : "FullDuplexSerialPlus"
  re            : "regex"

pub main
  Serialtest

pub SerialTest | teststr, pattern, resaddr, rslt, i  
'test inputing data from PST and echoing it back to the PST
' input string format: "$T,1,2,345"
  io.start(31, 30, 0, 9600)
  io.tx(16)
'  repeat
'    pauseMSec(1000)
'    io.Str(String(pst#NL, "Enter command: "))
'    io.getstr(teststr)
    teststr := string("$T,1,2,345")
    pattern := string("\$T\s*,($1[\d])\s*,($2[\d])\s*,($3[\d]+)\s*")
     
    io.str(string("String:", 13, 13))
    io.str(teststr)
    io.str(string(13, 13, "Pattern:", 13, 13))
    io.str(pattern)
     
    rslt := -cnt
    resaddr := re.match(teststr, pattern, re#NOALT)
    rslt += cnt
     
    io.str(string(13, 13, "Time: "))
    io.dec(rslt / 80_000)
    io.str(string(" ms."))
    io.str(string(13, 13, "Results:", 13))
     
    if (resaddr < 0)
      io.tx(13)
      io.str(string("Error #"))
      io.dec(-resaddr)
    elseif (resaddr == 0)
      io.tx(13)
      io.str(string("No match."))
    else
      repeat i from 0 to 9
        if (rslt := long[resaddr][i])
          io.tx(13)
          io.dec(i)
          io.str(string(": "))
          io.str(re.field(i))
     
      io.str(string(13, 13, "Remainder of string:", 13, 13))
      io.str(re.remainder)


PUB pauseMSec(Duration)
'' Pause execution in milliseconds.
'' Duration = number of milliseconds to delay
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)


{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}                  